from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, String, File

Coalescent_V0_1_0 = CommandToolBuilder(tool="coalescent", base_command=["coalescent"], inputs=[ToolInput(tag="in_arg_parameter_file", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="[ --paramfile ] arg                parameter file")), ToolInput(tag="in_arg_genetic_map", input_type=Boolean(optional=True), prefix="-R", doc=InputDocumentation(doc="[ --recombfile ] arg               genetic map file (if specified,\noverrides the one in paramfile)")), ToolInput(tag="in_gen_map_random_regions", input_type=Boolean(optional=True), prefix="--genmapRandomRegions", doc=InputDocumentation(doc="for each simulation use a randomly\nchosen subregion of the genetic map")), ToolInput(tag="in_arg_file_read", input_type=Boolean(optional=True), prefix="-J", doc=InputDocumentation(doc="[ --trajfile ] arg                 file from which to read sweep")), ToolInput(tag="in_arg_random_seed", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="[ --seed ] arg (=0)                random seed (0 to use current time)")), ToolInput(tag="in_arg_max_dist", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="[ --max-coal-dist ] arg            max dist betw segs for coalescence")), ToolInput(tag="in_use_convex_hull", input_type=Boolean(optional=True), prefix="-U", doc=InputDocumentation(doc="[ --max-coal-dist-cvx-hull ]       use convex hull for max coal dist")), ToolInput(tag="in_arg_shift_locations", input_type=Boolean(optional=True), prefix="-G", doc=InputDocumentation(doc="[ --genmapshift ] arg              shift all genmap locations by this")), ToolInput(tag="in_apx_min_factor", input_type=Int(optional=True), prefix="--apx-min-factor", doc=InputDocumentation(doc="enable coalapx only when pop size\nexceeds active sample size by this\nfactor (experimental)")), ToolInput(tag="in_apx_rej_samp", input_type=Int(optional=True), prefix="--apx-rej-samp", doc=InputDocumentation(doc="(=1)               use rejection sampling (experimental)")), ToolInput(tag="in_sweep_three_no_one_sided_re_combs", input_type=Boolean(optional=True), prefix="--sweep3-no-one-sided-recombs", doc=InputDocumentation(doc="handle one-sided recombs (experimental)")), ToolInput(tag="in_show_one_sim_progress", input_type=Boolean(optional=True), prefix="--show-one-sim-progress", doc=InputDocumentation(doc="show progress of coalescence in each")), ToolInput(tag="in_t_raj_only", input_type=Boolean(optional=True), prefix="--traj-only", doc=InputDocumentation(doc="just simulate trajectories and output\npresent-day freqs")), ToolInput(tag="in_arg_base_name", input_type=Boolean(optional=True), prefix="-o", doc=InputDocumentation(doc="[ --outfilebase ] arg              base name for output files in cosi")), ToolInput(tag="in_tp_ed", input_type=String(optional=True), prefix="--tped", doc=InputDocumentation(doc="write output to stdout in tped format,\nto files pfx-rep-pop.tped")), ToolInput(tag="in_output_pop_info", input_type=Boolean(optional=True), prefix="--output-pop-info", doc=InputDocumentation(doc="output pop info in ms format output")), ToolInput(tag="in_output_gen_map", input_type=Boolean(optional=True), prefix="--output-gen-map", doc=InputDocumentation(doc="output genetic map in ms format output")), ToolInput(tag="in_arg_number_decimal", input_type=Boolean(optional=True), prefix="-P", doc=InputDocumentation(doc="[ --output-precision ] arg         number of decimal places used for\nfloats in the outputs")), ToolInput(tag="in_arg_file_output", input_type=File(optional=True), prefix="-j", doc=InputDocumentation(doc="[ --trajoutfile ] arg              file to which to output sweep")), ToolInput(tag="in_output_mutation_ages", input_type=Boolean(optional=True), prefix="-M", doc=InputDocumentation(doc="[ --write-mut-ages ]               output mutation ages")), ToolInput(tag="in_output_recombination_locations", input_type=Boolean(optional=True), prefix="-L", doc=InputDocumentation(doc="[ --write-recomb-locs ]            output recombination locations")), ToolInput(tag="in_output_arg_edges", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="[ --output-ARG ]                   output ARG edges.  Edges are written in\nms output format (see -m option), one\nper line, after the '//' line but\nbefore the 'segsites: ' line of each\nsimulation. Format is:\nE <edgeKind> <node_1_id> <node_2_id>\n<node_1_generation> <node_2_generation>\n<seg_1_beg> <seg_1_end> ... <seg_k_beg>\n<seg_k_end>.\nEdge kinds are: R, recombination; G,\ngene conversion; C, coalescence.\nseg_i_beg, seg_i_end give chromosomal\nsegments inherited along the edge;\nlocations are values in [0.0,1.0]\nrepresenting locations within the\nsimulated region.")), ToolInput(tag="in_position_output_mutation", input_type=Boolean(optional=True), prefix="-C", doc=InputDocumentation(doc="[ --write-mut-contexts ] position  output mutation contexts for these")), ToolInput(tag="in_print_version_info", input_type=Boolean(optional=True), prefix="-V", doc=InputDocumentation(doc="[ --version ]                      print version info and compile-time")), ToolInput(tag="in__show_progress", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="[ --show-progress ] [=arg(=10)]    show progress")), ToolInput(tag="in_arg_log_file", input_type=Boolean(optional=True), prefix="-l", doc=InputDocumentation(doc="[ --logfile ] arg                  log file")), ToolInput(tag="in_arg_seg_file", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="[ --segfile ] arg                  seg file")), ToolInput(tag="in_arg_delta_factor", input_type=Boolean(optional=True), prefix="-d", doc=InputDocumentation(doc="[ --deltaTfactor ] arg (=1)        delta factor for sweep")), ToolInput(tag="in_compute_tree_size", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="[ --tree-size-only ]               compute tree size only")), ToolInput(tag="in_print_number_recombs", input_type=Boolean(optional=True), prefix="-k", doc=InputDocumentation(doc="[ --show-num-recombs ]             print number of recombs")), ToolInput(tag="in_do_simulation_quit", input_type=Boolean(optional=True), prefix="-S", doc=InputDocumentation(doc="[ --sim-and-quit ]                 do simulation and quit")), ToolInput(tag="in_output_sim_times", input_type=Boolean(optional=True), prefix="--output-sim-times", doc=InputDocumentation(doc="for each sim output the time it took")), ToolInput(tag="in_output_end_gens", input_type=Boolean(optional=True), prefix="--output-end-gens", doc=InputDocumentation(doc="for each sim output the generation at\nwhich it ended")), ToolInput(tag="in_stop_after_minutes", input_type=Int(optional=True), prefix="--stop-after-minutes", doc=InputDocumentation(doc="(=0)         stop simulation after this many minutes")), ToolInput(tag="in_custom_stats", input_type=Boolean(optional=True), prefix="--custom-stats", doc=InputDocumentation(doc="compute custom stats")), ToolInput(tag="in_custom_stats_exclude_pop", input_type=Int(optional=True), prefix="--custom-stats-exclude-pop", doc=InputDocumentation(doc="(=-1)  when computing custom stats, exclude\nthis pop\n")), ToolInput(tag="in_arg_number_simulations", input_type=String(), position=0, doc=InputDocumentation(doc="-n [ --nsims ] arg (=1)               number of simulations to output")), ToolInput(tag="in_delta", input_type=String(), position=1, doc=InputDocumentation(doc="-E [ --sweep-frac-sample ]            sweep end freq specifies exact sample ")), ToolInput(tag="in_fraction", input_type=String(), position=2, doc=InputDocumentation(doc="--apx-with-traj-ok                    enable coalapx even when pop size traj ")), ToolInput(tag="in_sim", input_type=String(), position=0, doc=InputDocumentation(doc="--pois-max-steps arg (=100000)        max # of steps when evaluating waiting ")), ToolInput(tag="in_times", input_type=String(), position=1, doc=InputDocumentation(doc="--pois-prec arg (=1.0000000000000001e-05)")), ToolInput(tag="in_format", input_type=String(), position=0, doc=InputDocumentation(doc="-m [ --outms ]                        write output to stdout in ms format")), ToolInput(tag="in_t_output_tree", input_type=String(), position=0, doc=InputDocumentation(doc="-T [ --write-tree-stats ]             output tree stats")), ToolInput(tag="in_locations", input_type=String(), position=1, doc=InputDocumentation(doc="--drop-singletons fraction            drop this fraction of singleton SNPs")), ToolInput(tag="in_options", input_type=String(), position=0, doc=InputDocumentation(doc="-v [ --verbose ]                      verbose output"))], outputs=[ToolOutput(tag="out_arg_file_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_arg_file_output", type_hint=File()), doc=OutputDocumentation(doc="[ --trajoutfile ] arg              file to which to output sweep"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Coalescent_V0_1_0().translate("wdl", allow_empty_container=True)

